<?php
/*
    DOKEOS - elearning and course management software

    For a full list of contributors, see documentation/credits.html

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
    See "documentation/licence.html" more details.

    Contact: Zhong	poopsoft@163.com
*/


/**
*	Code library for HotPotatoes integration.
*	@package iilearn.exercise
* 	@author
* 	@version $Id: question_list_admin.inc.php 11057 2007-02-05 08:56:17Z elixir_julian $
*/


/**
==============================================================================
*	QUESTION LIST ADMINISTRATION
*
*	This script allows to manage the question list
*	It is included from the script admin.php
*
*	@author Olivier Brouckaert
*	@package iilearn.exercise
==============================================================================
*/

// ALLOWED_TO_INCLUDE is defined in admin.php
if(!defined('ALLOWED_TO_INCLUDE'))
{
	exit();
}


// moves a question up in the list
if(isset($_GET['moveUp']))
{
	$objExercise->moveUp(intval($_GET['moveUp']));
	$objExercise->save();
}

// moves a question down in the list
if(isset($_GET['moveDown']))
{
	$objExercise->moveDown(intval($_GET['moveDown']));
	$objExercise->save();
}

// deletes a question from the exercise (not from the data base)
if($deleteQuestion)
{

	// if the question exists
	if($objQuestionTmp = Question::read($deleteQuestion))
	{
		$objQuestionTmp->delete($exerciseId);

		// if the question has been removed from the exercise
		if($objExercise->removeFromList($deleteQuestion))
		{
			$nbrQuestions--;
		}
	}

	// destruction of the Question object
	unset($objQuestionTmp);
}

Question :: display_type_menu ();
?>

<table width="100%"100%><tr><td align="center"><table width="95%"0%><tr><td>
<table class="data_table">
<tr class="row_odd" bgcolor='#e6e6e6'>
<th width="70%"><b><?php echo get_lang('Question'); ?></b></th>
<th width="15%"><b><?php echo get_lang('Type');?></b></th>
<th width="15%">&nbsp;</th>
</tr>

<?php
if($nbrQuestions)
{
	$questionList=$objExercise->selectQuestionList();

	$i=1;
	foreach($questionList as $id)
	{
		$objQuestionTmp = Question :: read($id);
?>

<tr <?php if($i%2==0) echo 'class="row_odd"'; else echo 'class="row_even"'; ?>>
  <td align="left"><?php echo "$i. ".$objQuestionTmp->selectTitle(); ?></td> <td align="left"><?php eval('echo get_lang('.get_class($objQuestionTmp).'::$explanationLangVar);'); ?></td>
  <td align="left"> <a href="<?php echo $_SERVER['PHP_SELF']; ?>?myid=1&editQuestion=<?php echo $id; ?>"> <?php echo Display::return_icon('edit.gif', get_lang('Modify'), array('align'=>'absmiddle')); ?> </a> <a href="<?php echo $_SERVER['PHP_SELF']; ?>?deleteQuestion=<?php echo $id; ?>" onclick="javascript:if(!confirm('<?php echo addslashes(htmlentities(get_lang('ConfirmYourChoice'), ENT_NOQUOTES, SYSTEM_CHARSET)); ?>')) return false;"> <?php echo Display::return_icon('delete.gif', get_lang('Delete'), array('align'=>'absmiddle')); ?> </a>

	<?php
		if($i != 1)
		{
?>

	<a href="<?php echo $_SERVER['PHP_SELF']; ?>?moveUp=<?php echo $id; ?>"> <?php echo Display::return_icon('up.gif', get_lang('MoveUp'), array('align'=>'absmiddle')); ?> </a>

<?php
		}

		if($i != $nbrQuestions)
		{
?>

	<a href="<?php echo $_SERVER['PHP_SELF']; ?>?moveDown=<?php echo $id; ?>"> <?php echo Display::return_icon('down.gif', get_lang('MoveDown'), array('align'=>'absmiddle')); ?> </a>

<?php
		}
?>

 </td>

<?php
		$i++;

		unset($objQuestionTmp);
?>
</tr>
	<?php }
}

if(!$i)
{
	
?>
<tr>
  <td colspan="3" class="row_odd"><i><?php echo get_lang('NoQuestion'); ?></i></td>
</tr>
<?php } ?>

</table>

</td></tr></table></td></tr></table>
